<!------------------------------------------------------------------------------
cf_advancedemail
Used in conjunction with cf_advancedemailparam to send multipart/related and
multipart/alternative emails.

Copyright (c) 2000-2001, Jochem van Dieten
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, 
	  this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, 
	  this list of conditions and the following disclaimer in the documentation 
	  and/or other materials provided with the distribution.
    * Neither the name of the author nor the names of its contributors 
	  may be used to endorse or promote products derived from this software 
	  without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE 
DISCLAIMED. IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE FOR ANY 
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON 
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

------------------------------------------------------------------------------->
<cfif not thistag.HasEndTag>
	<cfthrow message="CF_advancedemail requires an end tag">
</cfif>

<cfif ThisTag.ExecutionMode IS 'start'>
<!--- INITIALIZE SOME PARAMETERS TO USE THROUGHOUT THE TEMPLATE --->
<cfscript>
// If the structure exists it might have cached info so don't overwrite
if (NOT IsDefined("request.AdvancedEmail"))
	request.AdvancedEmail = StructNew();

// If the array exists it might have cached info so don't overwrite
if (NOT IsDefined("request.AdvancedEmail.CachedFilesArray"))
	request.AdvancedEmail.CachedFilesArray = ArrayNew(1);

request.AdvancedEmail.AttachmentArray = ArrayNew(2);
request.AdvancedEmail.HeaderArray = ArrayNew(2);
</cfscript>


<cfelseif ThisTag.ExecutionMode IS 'end'>

<cflock scope="SERVER" timeout="2" type="READONLY">
	<cfset variables.OS.Name = Duplicate(Server.OS.Name)>
</cflock>

<cfif IsDefined("request.AdvancedEmail.URL")>
	<cfhttp method="GET" url="#request.AdvancedEmail.URL#" timeout="10" resolveurl="Yes"></cfhttp>
	<cfset request.AdvancedEmail.HTMLText = cfhttp.FileContent>
	<cfset cfhttp.FileContents = "">
	<cfset attributes.inline = TRUE>
</cfif>

<!--- CHECK REQUIRED ATTRIBUTES AND GENERATE NICE ERRORMESSAGE --->
<cfscript>
// Move GeneratedContent to variable and clear GeneratedContent to purge HTML-stream
if (not IsDefined("request.AdvancedEmail.HTMLText"))
	request.AdvancedEmail.HTMLText = thistag.generatedcontent;
thistag.generatedcontent = "";

// Check the required attributes
RequiredAttributesList = "from,to";
ErrorMessage = "The following required attribute(s) need to be supplied:<ul>";
for (CurrentAttribute = 1 ; CurrentAttribute LTE ListLen(RequiredAttributesList) ; CurrentAttribute = CurrentAttribute + 1)
	if (NOT IsDefined("attributes." & ListGetAt(RequiredAttributesList,CurrentAttribute)))
		ErrorMessage = ErrorMessage & "<li>" & ListGetAt(RequiredAttributesList,CurrentAttribute);
ErrorMessage = ErrorMessage & "</ul>";
</cfscript>

<cfif ErrorMessage IS NOT "The following required attribute(s) need to be supplied:<ul></ul>">
	<cfthrow message="Required attribute(s) of CF_ADVANCEDEMAIL not found!!!" detail="#Errormessage#">
</cfif>


<!--- Try to get some optional attributes from the registry if not specified. --->
<cfif NOT IsDefined("attributes.spooldir") OR NOT IsDefined("attributes.server")>
	<cftry>
		<cfif NOT IsDefined("attributes.spooldir")>
			<CFREGISTRY
				ACTION="Get"
				BRANCH="HKEY_LOCAL_MACHINE\Software\Allaire\ColdFusion\CurrentVersion\Mail" 
				ENTRY="BaseDirectory" 
				TYPE="String" 
				VARIABLE="attributes.spooldir"
			>
		</cfif>
		<cfif NOT IsDefined("attributes.server")>
			<CFREGISTRY
				ACTION="Get"
				BRANCH="HKEY_LOCAL_MACHINE\Software\Allaire\ColdFusion\CurrentVersion\Mail" 
				ENTRY="MailServer" 
				TYPE="String" 
				VARIABLE="attributes.server"
			>
		</cfif>

		<cfcatch type="Any">
			<cfthrow message="Unable to read Server and Spooldir from Registry" detail="CF_ADVANCEDEMAIL tried to read the default mailserver and spooldir from the Registry but failed. The most likely cause of this is that the CFREGISTRY tag has bee disabled. You need to specify the SERVER and SPOOLDIR attributes manually.">
		</cfcatch>

	</cftry>
</cfif>


<!--- SET OPTIONAL ATTRIBUTES TO DEFAULT VALUES IF NOT DEFINED --->
<cftry>
	<cfif NOT IsDefined("attributes.port")>
		<CFREGISTRY
			ACTION="Get"
			BRANCH="HKEY_LOCAL_MACHINE\Software\Allaire\ColdFusion\CurrentVersion\Mail" 
			ENTRY="SMTPPort" 
			TYPE="String" 
			VARIABLE="attributes.port"
		>
	</cfif>
	<cfif NOT IsDefined("attributes.timeout")>
		<CFREGISTRY
			ACTION="Get"
			BRANCH="HKEY_LOCAL_MACHINE\Software\Allaire\ColdFusion\CurrentVersion\Mail" 
			ENTRY="Timeout" 
			Type="String"
			VARIABLE="attributes.timeout"
		>
	</cfif>

	<cfcatch type="Any">
		<cfparam name="attributes.port" default="25">
		<cfparam name="attributes.timeout" default="60">
	</cfcatch>

</cftry>

<cfif IsDefined("attributes.TempDir")>
	<cfset request.AdvancedEmail.TempDir = attributes.TempDir>
</cfif>
<cfif IsDefined("attributes.Exclude")>
	<cfset request.AdvancedEmail.ExcludedFileExtensions = attributes.ExcludedFileExtensions>
<cfelse>
	<cfset request.AdvancedEmail.ExcludedFileExtensions = "cfm,cfml,dbm,jsp,cgi,pl,exe,dll,js">
</cfif>

<cfparam name="attributes.cfversion" default="4.5.0">
<cfparam name="attributes.mode" default="silent">
<cfparam name="attributes.cache" default=TRUE>
<cfparam name="attributes.type" default="Alternative">
<cfparam name="attributes.timezoneoverride" default="0000">
<cfparam name="attributes.inline" default=TRUE>
<cfparam name="attributes.format" default="CF">



<cfscript>
// If run from ISP the spooldir should be hardcoded for extra security
request.AdvancedEmail.SpoolDir = attributes.Spooldir;

// CONSTANTS
if (variables.OS.Name IS "UNIX") {
	CF_CRLF = chr(10);
	DS = "/";
	}
else {
	CF_CRLF = chr(13) & chr(10);
	DS = "\";
	}

CRLF = chr(13)&chr(13)&chr(10);
rootboundary   = "----=_NextPart_000_0000_ABCDEF01";
nestedboundary = "----=_NextPart_000_0001_ABCDEF01";

// COMBINE HEADERINFO IN REQUEST.ADVANCEDEMAIL.HEADERARRAY
// Get the correct reply-to
if (NOT IsDefined("request.AdvancedEmail.Replyto")) {
	TempArray = ArrayNew(1);
	TempArray[1] = 'Reply-to';
	TempArray[2] = attributes.From;
	ArrayPrepend(request.AdvancedEmail.HeaderArray,TempArray);
	}


// Get the correct to
TempArray = ArrayNew(1);
TempArray[1] = 'To';
TempArray[2] = attributes.To;
ArrayPrepend(request.AdvancedEmail.HeaderArray,TempArray);


// Get the correct subject
if (NOT IsDefined("request.AdvancedEmail.Subject")) {
	for (variables.CurrentTag = 1 ; variables.CurrentTag LTE ListLen(request.AdvancedEmail.HTMLText,chr(60)) ; variables.CurrentTag = variables.CurrentTag + 1) {
		if (Left(ListGetAt(request.AdvancedEmail.HTMLText,CurrentTag,chr(60)),5) IS 'title') {
			TempArray = ArrayNew(1);
			TempArray[1] = 'Subject';
			TempArray[2] = ListRest(ListGetAt(request.AdvancedEmail.HTMLText,CurrentTag,chr(60)),chr(62));
			ArrayPrepend(request.AdvancedEmail.HeaderArray,TempArray);
			break;
			}
		}
	}


// Get the correct From
TempArray = ArrayNew(1);
TempArray[1] = 'From';
TempArray[2] = attributes.From;
ArrayPrepend(request.AdvancedEmail.HeaderArray,TempArray);


// Get the correct Date
Adjustedtime = DateAdd("h",ListFirst(attributes.timezoneoverride),DateAdd("m",ListLast(attributes.timezoneoverride),Now()));
TimeZoneInfo = GetTimeZoneInfo();
TimeZoneInfo.utcMinuteOffset = TimeZoneInfo.utcMinuteOffset+ListLast(attributes.timezoneoverride);
TimeZoneInfo.utcHourOffset = TimeZoneInfo.utcHourOffset+ListFirst(attributes.timezoneoverride);

TimeStamp = DateFormat(AdjustedTime,"ddd, dd mmm yyyy") & TimeFormat(AdjustedTime," HH:mm:ss ") & NumberFormat(-TimeZoneInfo.utcHourOffset,"+09") & NumberFormat(TimeZoneInfo.utcMinuteOffset,"90");
TempArray = ArrayNew(1);
TempArray[1] = 'Date';
TempArray[2] = TimeStamp;
ArrayPrepend(request.AdvancedEmail.HeaderArray,TempArray);


// Get the correct Mime Version
TempArray = ArrayNew(1);
TempArray[1] = 'X-Mailer';
TempArray[2] = 'cf_advancedemail 2.0 release candidate by Jochem van Dieten';
ArrayAppend(request.AdvancedEmail.HeaderArray,TempArray);

// Get the correct Mime Version
TempArray = ArrayNew(1);
TempArray[1] = 'Mime-version';
TempArray[2] = '1.0';
ArrayAppend(request.AdvancedEmail.HeaderArray,TempArray);


// Get the correct Content-Type
TempArray = ArrayNew(1);
TempArray[1] = 'Content-Type';
TempArray[2] = 'multipart/related; boundary="#RootBoundary#"';
ArrayAppend(request.AdvancedEmail.HeaderArray,TempArray);



// GET THE CORRECT PLAINTEXT AND HTMLTEXT
if (NOT IsDefined("request.AdvancedEmail.PlainText"))
	request.AdvancedEmail.PlainText = Request.AdvancedEmail.HTMLText;
request.AdvancedEmail.PlainText = REReplaceNoCase(Request.AdvancedEmail.PlainText,"[[:space:]]*<(script)[^>]*>[^<]*</script[^>]*>","","ALL");
request.AdvancedEmail.PlainText = REReplace(Request.AdvancedEmail.PlainText,"<[^>]+>","","ALL");
request.AdvancedEmail.PlainText = REReplace(Request.AdvancedEmail.PlainText,"[[:space:]]*#chr(13)##chr(10)#[[:space:]]*#chr(13)##chr(10)#","#chr(13)##chr(10)##chr(13)##chr(10)#","ALL");
request.AdvancedEmail.PlainText = Replace(request.AdvancedEmail.PlainText,"#chr(13)##chr(10)#","#chr(13)##chr(13)##chr(10)#","ALL");
request.AdvancedEmail.HTMLText = Replace(request.AdvancedEmail.HTMLText,"#chr(13)##chr(10)#","#chr(13)##chr(13)##chr(10)#","ALL");


// MAKE THE ATTACHMENTS INLINE IF APPROPRIATE
// Find all occurences of src="...." and dump them in an array
loop1 = 'Keep running until the search returns 0 hits';
StartValue = 1;
while (loop1 IS NOT 1) {
	FindResultsArray = REFindNoCase("src=""[^""]+""",request.AdvancedEmail.HTMLText,StartValue,"TRUE");
	if (FindResultsArray.pos[1] IS 0) break;
// Following line is used for generalized remote images handling
	if (attributes.inline IS TRUE OR (attributes.inline IS "local" AND Mid(request.AdvancedEmail.HTMLText,FindResultsArray.pos[1] + 5,7) IS NOT "http://")) {
		TempArray = ArrayNew(1);
		TempArray[1] = Mid(request.AdvancedEmail.HTMLText,FindResultsArray.pos[1]+5,FindResultsArray.len[1]-6);
		TempArray[2] = ListFirst(GetFileFromPath(TempArray[1]),"?");
		if (ListFind(request.AdvancedEmail.ExcludedFileExtensions, ListLast(TempArray[2],"."))) break;
		TempArray[3] = "";
		TempArray[4] = attributes.Cache;
		TempArray[6] = "unknown/unknown";
		if (attributes.inline IS TRUE  OR (attributes.inline IS "local" AND Left(TempArray[1],7) IS NOT "http://"))
			TempArray[7] = TRUE;
		else
			TempArray[7] = FALSE;
		TempArray[8] = FindResultsArray.pos[1];
		TempArray[9] = FindResultsArray.len[1];
		ArrayAppend(request.AdvancedEmail.AttachmentArray,TempArray);
		}
	StartValue = FindResultsArray.pos[1] + FindResultsArray.len[1];
	}


// Replace src="path" with src="cid:" if appropriate
for (index = ArrayLen(request.AdvancedEmail.AttachmentArray) ; index GT 0 ; index=index-1) {
	if (request.AdvancedEmail.AttachmentArray[index][7] IS TRUE) {
		request.AdvancedEmail.AttachmentArray[index][3] = "cid:920501010@06102000-364#index#";
		request.AdvancedEmail.HTMLText = RemoveChars(request.AdvancedEmail.HTMLText,request.AdvancedEmail.AttachmentArray[index][8]+5,request.AdvancedEmail.AttachmentArray[index][9]-6);
		request.AdvancedEmail.HTMLText = Insert(request.AdvancedEmail.AttachmentArray[index][3],request.AdvancedEmail.HTMLText,request.AdvancedEmail.AttachmentArray[index][8]+4);
		}
	}


</cfscript>

<!--- ADD THE BASE64 ENCODED IMAGE TO REQUEST.ADVANCEDEMAIL.ATTACHMENTARRAY AND SET THE MIME-TYPE --->
<cfloop from="1" to="#ArrayLen(request.AdvancedEmail.AttachmentArray)#" index="CurrentAttachment">
	<cfset FileIsCached = FALSE>
	
	<!--- If possible, use cached version  --->
	<cfif request.AdvancedEmail.AttachmentArray[CurrentAttachment][4] IS TRUE AND StructKeyExists(request.AdvancedEmail, "CachedFilesArray")>
		<cfloop from="1" to="#ArrayLen(request.AdvancedEmail.CachedFilesArray)#" index="CurrentFile">
			<cfif request.AdvancedEmail.CachedFilesArray[CurrentFile][1] IS request.AdvancedEmail.AttachmentArray[CurrentAttachment][1]>
				<cfset request.AdvancedEmail.AttachmentArray[CurrentAttachment][5] = request.AdvancedEmail.CachedFilesArray[CurrentFile][2]>
				<cfset FileIsCached = TRUE>
				<cfset request.AdvancedEmail.AttachmentArray[CurrentAttachment][10] = "from <b>Cache</b>">
				<cfbreak>
			</cfif>
		</cfloop>
	</cfif>

	<cfif NOT FileIsCached>
	<!--- We need the uncached version --->
		<cfif Left(request.AdvancedEmail.AttachmentArray[CurrentAttachment][1],7) IS "http://">
			<cflock name="#Hash(LCase(request.AdvancedEmail.TempDir))#" type="EXCLUSIVE" timeout="10">
				<cfhttp method="GET" url="#request.AdvancedEmail.AttachmentArray[CurrentAttachment][1]#" path="#request.AdvancedEmail.tempdir#"></cfhttp>
				<cfset request.AdvancedEmail.AttachmentArray[CurrentAttachment][1] = request.AdvancedEmail.tempdir & request.AdvancedEmail.AttachmentArray[CurrentAttachment][2]>
				<cffile action="READ" file="#request.AdvancedEmail.AttachmentArray[CurrentAttachment][1]#" variable="temp">
				<cffile action="DELETE" file="#request.AdvancedEmail.AttachmentArray[CurrentAttachment][1]#">
			</cflock>
		<cfelse>
			<cffile action="READ" file="#request.AdvancedEmail.AttachmentArray[CurrentAttachment][1]#" variable="temp">
		</cfif>
		
		<cfscript>
		temp = ToBase64(temp);
		CurrentPosition = 72;
		// Base64 encoded stuff has a maximum line length of 1000 characters (but 72 looks nice)
		while (CurrentPosition LTE Len(temp)) {
			temp = Insert(CRLF,temp,CurrentPosition);
			CurrentPosition = CurrentPosition + 74;
			}
		// If caching is enabled write it to the cache.
		if (request.AdvancedEmail.AttachmentArray[CurrentAttachment][4] IS TRUE) {
			TempArray = ArrayNew(1);
			TempArray[1] = request.AdvancedEmail.AttachmentArray[CurrentAttachment][1];
			TempArray[2] = temp;
			ArrayAppend(request.AdvancedEmail.CachedFilesArray, TempArray);
			}
		request.AdvancedEmail.AttachmentArray[CurrentAttachment][5] = temp;
		request.AdvancedEmail.AttachmentArray[CurrentAttachment][10] = "from <b>HD</b>";
		</cfscript>
	</cfif>

	<!--- Set the MIME-type if not set before --->
	<cfif request.AdvancedEmail.AttachmentArray[CurrentAttachment][6] IS "unknown/unknown">
		<cfswitch expression="#ListLast(request.AdvancedEmail.AttachmentArray[CurrentAttachment][2],".")#">
			<cfcase value="gif">
				<cfset request.AdvancedEmail.AttachmentArray[CurrentAttachment][6]="image/gif">
			</cfcase>
			<cfcase value="jpg,jpeg">
				<cfset request.AdvancedEmail.AttachmentArray[CurrentAttachment][6]="image/jpg">
			</cfcase>
			<cfcase value="htm,html,shtml,shtm,shm,cfm,cfml">
				<cfset request.AdvancedEmail.AttachmentArray[CurrentAttachment][6]="text/html">
			</cfcase>
			<cfdefaultcase>
			</cfdefaultcase>
		</cfswitch>
	</cfif>

</cfloop>


<!--- BUILD A VARIABLE "CONTENT" THAT CONTAINS THE ENIRE MESSAGE --->
<cfscript>
/*
Email messages consist of grouped data. The separation of the data groups 
is a white line. White lines will be attached after every block of info, so
every block of info should end with:
content=content & CRLF;
*/ 

// HEADER
content = "";
Summary = "<h2>Summary:</h2>#CRLF#<ul>";

if (attributes.Format IS NOT "body") {
	if (attributes.Format IS "CF") {
		// The ColdFusion mail header
		content = content & "x-cf-version: " & attributes.cfversion & CF_CRLF;
		content = content & "x-cf-server: "  & attributes.server    & CF_CRLF;
		content = content & "x-cf-port: "    & attributes.port      & CF_CRLF;
		content = content & "x-cf-timeout: " & attributes.timeout   & CF_CRLF;
		content = content & "x-cf-from: "    & attributes.from      & CF_CRLF;
		content = content & "x-cf-to: "      & attributes.to        & CF_CRLF;
		content = content & CF_CRLF;
		Summary = Summary&"#CRLF#<li>ColdFusion Header";
		}
	
	// The normal mail header
	for (index = 1 ; index LTE ArrayLen(request.AdvancedEmail.HeaderArray) ; index = index + 1)
		content = content & request.AdvancedEmail.HeaderArray[index][1] & ": " & request.AdvancedEmail.HeaderArray[index][2] & CRLF;
	content = content & CRLF;
	Summary = Summary & "#CRLF#<li>Header";
	}


// Announce a MIME message
content = content & "This is a multi-part message in MIME format." & CRLF;
content = content & CRLF;


// BODY
content = content & '--' & RootBoundary & CRLF;
if (attributes.type IS 'Alternative') {
	content = content & 'Content-Type: multipart/alternative; boundary="' & NestedBoundary & '"' & CRLF;
	content = content & CRLF;
	content = content & CRLF;

	content = content & '--' & NestedBoundary & CRLF;
	}

if (attributes.type IS NOT 'HTML') {
	content = content & 'Content-Type: text/plain; charset="iso-8859-1"' & CRLF;
	content = content & 'Content-Transfer-Encoding: 7bit' & CRLF;
	content = content & CRLF;

	content = content & request.AdvancedEmail.PlainText & CRLF;
	content = content & CRLF;
	Summary = Summary&"#CRLF#<li>Text";
	}

if (attributes.type IS 'Alternative')
	content = content & '--' & NestedBoundary & CRLF;

if (attributes.type IS NOT 'Text') {
	content = content & 'Content-Type: text/html; charset="iso-8859-1"' & CRLF;
	content = content & 'Content-Transfer-Encoding: 7bit' & CRLF;
	content = content & CRLF;
	
	content = content & request.AdvancedEmail.HTMLText & CRLF;
	content = content & CRLF;
	Summary = Summary & "#CRLF#<li>HTML";
	}

if (attributes.type IS 'Alternative')
	content = content & '--' & NestedBoundary & '--' & CRLF;
content = content & CRLF;


// ATTACHMENTS
if (ArrayLen(request.AdvancedEmail.AttachmentArray)) {
	Summary = Summary & "#CRLF#<li>Attachments:#CRLF#<ul>";
	// Attachments
	for (index = 1 ; index LTE ArrayLen(request.AdvancedEmail.AttachmentArray) ; index = index + 1) {
		content = content & '--' & RootBoundary & CRLF;
		content = content & 'Content-Type: ' & request.AdvancedEmail.AttachmentArray[index][6] & '; name="' & request.AdvancedEmail.AttachmentArray[index][2] & '"' & CRLF;
		content = content & 'Content-Transfer-Encoding: base64' & CRLF;
		if (request.AdvancedEmail.AttachmentArray[index][3] IS "")
			content = content & 'Content-Disposition: attachment; filename="' & request.AdvancedEmail.AttachmentArray[index][2] & '"' & CRLF;
		else
			content = content & 'Content-ID: <' & ListLast(request.AdvancedEmail.AttachmentArray[index][3],":") & '>' & CRLF;
		content = content & CRLF;
		
		content = content & RemoveChars(request.AdvancedEmail.AttachmentArray[index][5],Len(request.AdvancedEmail.AttachmentArray[index][5]),1) & CRLF;
		content = content & CRLF;

		Summary = Summary & "#CRLF#<li>#request.AdvancedEmail.AttachmentArray[index][1]# #request.AdvancedEmail.AttachmentArray[index][10]#";
		if (request.AdvancedEmail.AttachmentArray[index][7])
			Summary = Summary & " <b>inline</b>";
		}
	variables.Summary = Summary & "#CRLF#</ul>#CRLF#</ul>";
	}

content=content & '--' & RootBoundary & '--' & CRLF;
content=content & CRLF;
</cfscript> 


<cfif IsDefined("attributes.variable")>
	<cfset temp = SetVariable("caller." & attributes.variable, content)>
	<cfset Summary = Summary & "<p>Content was written to #attributes.variable#.</p>">
<cfelse>
	<!--- WRITE "CONTENT" IN A 'SINGLE-THREADED' WAY TO THE SPOOLDIR --->
	<cfif attributes.mode IS 'Silent' OR attributes.mode IS 'Debug'>
		<cfset filename = CreateUUID() & ".cfmail">
		<cfset writefile = request.advancedemail.spooldir & DS & "spool" & DS & filename>
		<cfif NOT FileExists(writefile)>
			<cflock name="#Hash(LCase(writefile))#" type="EXCLUSIVE" timeout="10">
				<cfif NOT FileExists(writefile)>
					<cffile action="WRITE" file="#writefile#" output="#content#" addnewline="No">
					<cfset Summary = Summary & "<p>File was written to #writefile#.</p>">
				</cfif>
			</cflock>
		</cfif>
	</cfif>
</cfif>


<!---CLEANUP OF REQUEST.ADVANCEDEMAIL STRUCTURE AND OUTPUT REQUIRED DATA FOR DEBUGGING --->
<cfscript>
// Show debugoutput??
if (attributes.mode IS 'ViewOnly' OR attributes.mode IS 'Debug' OR attributes.mode IS 'SummaryOnly') {
	thistag.generatedcontent = Summary;
	if (attributes.mode IS NOT 'SummaryOnly')
		thistag.generatedcontent = Summary & "<h2>Message:</h2>" & CRLF & HTMLCodeFormat(content) & CRLF;
	}

// Cleanup of the request scope, except for the BASE64 file cache
variables.CachedFilesArray = Duplicate(request.AdvancedEmail.CachedFilesArray);
StructClear(request.AdvancedEmail);
request.AdvancedEmail.CachedFilesArray = Duplicate(variables.CachedFilesArray);
variables.CachedFilesArray = "";
</cfscript>

</cfif>

